<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ page import="java.util.*" %>
<%@ page import="java.sql.*" %>
<%@ page import="com.invoqsystems.apex.web.cocoon.jsp.*" %>
<%@ page import="org.apache.commons.lang.StringEscapeUtils" %>

<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>

<jsp:useBean id="subscriptionBean"
             class="com.invoqsystems.apex.web.cocoon.jsp.SubscriptionBeanImpl"
             scope="session" />


<%
  /**
   * You can change these following variables to match the correct information, if necessary.
   */
  final int MAX_DISPLAY_CHARACTERS = 60;
  final int MAX_RECIPIENT_DISPLAY_CHARACTERS = 80;

  /**
   * this is the URL used to display the Hostname Search Window.
   * The directory structure should be based on the disk location, change if necessary.
   */

  final String NODE_PREDICATE_NAME = "Node";
  final String MANAGER_PREDICATE_NAME = "Manager";
  final String ALERT_GROUP_PREDICATE_NAME = "AlertGroup";
  final String SEVERITY_PREDICATE_NAME = "Severity";

  // Declare the connection information for the Object Server.
  //
  String OMNI_os_host = "localhost";
  String OMNI_os_port = "4100";
  String OMNI_os_method = "jdbc:sybase:Tds:";
  String OMNI_os_constr = OMNI_os_method + OMNI_os_host + ":" + OMNI_os_port;
  String OMNI_NetcoolUser = "xmatters";
  String OMNI_UID = "99999";
  String APDT_netcool_password = "xmatters";

  // Query strings
  final String QUERY_NODE = "select Node from alerts.status where Node != '';";
  final String QUERY_MANAGER = "select Manager from alerts.status;";
  final String QUERY_ALERT_GROUP = "select AlertGroup from alerts.status;";

  // Specify true if you want to use predicate values from the event domain instead of querying Netcool
  final boolean USE_PREDICATE_VALUES_FOR_NODE = false;
  final boolean USE_PREDICATE_VALUES_FOR_MANAGER = false;
  final boolean USE_PREDICATE_VALUES_FOR_ALERT_GROUP = false;

%>

<subscription-panel xmlns:fi="http://apache.org/cocoon/forms/1.0#instance"
                    xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
					onsubmit="return validateForm(this);"
					id="OMWSubscriptionForm">

<%
  // set up the map for storing the selected values for each predicate
  final HashMap<String, ArrayList<String>> selectedPredicateValuesMap = new HashMap<String, ArrayList<String>>();
  final HashMap<String, PredicateBean> predicateNameMap = new HashMap<String, PredicateBean>();
  final HashMap<String, String> predicateSummaryNamesMap = new HashMap<String, String>();

  final StringBuffer summaryName = new StringBuffer();
  // collect the selected predicate values, and pre-populated values
  Iterator<PredicateBeanImpl> iterator = subscriptionBean.getPredicateIterator();


  // set up the data elements necessary for storing the database results
  List<String> nodeList = new ArrayList<String>();
  List<String> managerList = new ArrayList<String>();
  List<String> alertGroupList = new ArrayList<String>();
  List<String> severityList = new ArrayList<String>();


  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     ArrayList<String> selectedValues = new ArrayList<String>();
     selectedValues.addAll(predicate.getSelectedValues());

     selectedPredicateValuesMap.put(predicate.getPredicateName(), selectedValues);
     predicateNameMap.put(predicate.getPredicateName(), predicate);

     if(!predicate.getSelectedValues().isEmpty())
     {
       summaryName.delete(0, summaryName.length());
	   if(predicate.hasAnySelectedValue())
       {
         summaryName.append("ANY");
       }
	   else
	   {
         Iterator<String> valIter = predicate.getSelectedValues().iterator();
         while(valIter.hasNext())
         {
           summaryName.append(valIter.next());
           if(valIter.hasNext())
             summaryName.append(", ");
           if(summaryName.length() > MAX_DISPLAY_CHARACTERS)
           {
             summaryName.setLength(MAX_DISPLAY_CHARACTERS);
             break;
           }
         }
	   }
       predicateSummaryNamesMap.put(predicate.getPredicateName(), summaryName.toString());
    }

    // Add preicate values if the USER_PREDICATE_VALUES boolean is set to true
    if (predicate.getPredicateName().equals(NODE_PREDICATE_NAME) && USE_PREDICATE_VALUES_FOR_NODE) {
      nodeList.addAll(predicate.getPredicateValues());
    } else if (predicate.getPredicateName().equals(MANAGER_PREDICATE_NAME) && USE_PREDICATE_VALUES_FOR_MANAGER) {
      managerList.addAll(predicate.getPredicateValues());
    } else if (predicate.getPredicateName().equals(ALERT_GROUP_PREDICATE_NAME) && USE_PREDICATE_VALUES_FOR_ALERT_GROUP) {
      alertGroupList.addAll(predicate.getPredicateValues());
    }

  }

  try
  {

    Class.forName( "com.sybase.jdbc2.jdbc.SybDriver" );

    Connection conn = DriverManager.getConnection(
      OMNI_os_constr,
      OMNI_NetcoolUser,
      APDT_netcool_password );

    ResultSet rs = null;
    Statement stmt = conn.createStatement();

    if (!USE_PREDICATE_VALUES_FOR_NODE) {
      rs = stmt.executeQuery(QUERY_NODE);
      while (rs.next())
      {
        String value = rs.getString(1).trim();
        if (!nodeList.contains(value))
          nodeList.add(value);
      }
      rs.close();
    }

    if (!USE_PREDICATE_VALUES_FOR_MANAGER) {
      rs = stmt.executeQuery(QUERY_ALERT_GROUP);
      while (rs.next())
      {
        String value = rs.getString(1).trim();
        if (!managerList.contains(value))
          managerList.add(value);
      }
      rs.close();
    }

    if (!USE_PREDICATE_VALUES_FOR_ALERT_GROUP) {
      rs = stmt.executeQuery(QUERY_MANAGER);
      while (rs.next())
      {
        String value = rs.getString(1).trim();
        if (!alertGroupList.contains(value))
          alertGroupList.add(value);
      }
      rs.close();
    }

    stmt.close();
    conn.close();
  }
  catch (Exception ex)
  {
    out.println("<div class=\"system-msg-error\">An error occured while processing the request: " + ex.getMessage() + "</div>");
  }

  // Determine if its AlarmPoint 3.2 or Later.
  boolean isLaterVersion;
  try
  {
    Class.forName("com.invoqsystems.apex.model.event.EventTemplateImpl");
    isLaterVersion = true;
  }
  catch(Exception ex)
  {
    isLaterVersion = false;
  }

  boolean creatingSubscription;
  if(isLaterVersion)
  {
    final String subId = (String)request.getParameter("subscriptionId");
    final String subDomainId = (String)request.getParameter("subscriptionDomainId");
    creatingSubscription = (subId == null || "0".equals(subId)) || subDomainId == null;
  }
  else
  {
    final String queryString = (String)request.getQueryString();
    creatingSubscription = queryString == null;
  }


  /**
   * This tab count will contain the total number tabs that will be displayed.
   */
  // THe total number of tabs that will be displayed
  int tabCount = 4;
  if(creatingSubscription)
  {
    tabCount--;
	if(!isLaterVersion && !subscriptionBean.isSelfSubscription()) // Managed Version 3.1 & <
	{
	  tabCount--;
	}
  }
  if(subscriptionBean.isSelfSubscription())
  {
    tabCount--;
  }
  if(subscriptionBean.allOverridesSuppressed() && subscriptionBean.isTimeframeSuppressed())
  {
    tabCount--;
  }

  /**
   * This maps the tab position for each predicate.
   */
  final HashMap<String, String> predicateTabPositionMap = new HashMap<String, String>();
  predicateTabPositionMap.put(NODE_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(MANAGER_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(ALERT_GROUP_PREDICATE_NAME, "1");
  predicateTabPositionMap.put(SEVERITY_PREDICATE_NAME, "1");
%>

<style media="screen" type="text/css">
  span.forms-tab {
    display: inline;
    position: relative;
    top: -1px;
    z-index: 1;
    overflow: hidden;
    font-weight: bold;
  	text-decoration: none;
    cursor: pointer;
    color: #555555;    
    background: transparent url(/static/images/layout/main-menu-bg-off.gif) no-repeat top left;
    padding: 6px 7px 1px 11px;
    border-right: 1px solid #666;
    border-bottom: 1px solid #666;
    border-top: none;
    border-left: none;
    margin: 0;
  }

  span.forms-tab:hover {
    background: transparent url(/static/images/layout/main-menu-bg-hover.gif) no-repeat top left;
  }

  span.forms-tab.forms-activeTab {
  	display: inline;
    position: relative;
    top: 1px;
    z-index: 10;
    overflow: hidden;
    cursor: default;
    color: #000000;
    background: transparent url(/static/images/layout/main-menu-bg-selected.gif) no-repeat top left;
    padding: 7px 7px 1px 11px;
    border-bottom: none;
  }

  span.forms-tab.forms-activeTab:hover {
    background-color: #FFF;
    position: relative;
  }

  span.forms-tabContent {
    background-color: #FFF;
    border: 1px solid #666;
    /*padding: 3em;*/
    position: relative;
    z-index: 2;
  }

  #sandbag-01,
  #sandbag-02 {
    clear: left;
    float: left;
    padding: 0pt; /*border: 1px solid #0f0;*/
  }

  #sandbag-01 {
    height: 10px;
    width: 160px;
  }

  #sandbag-02 {
    height: 10px;
    width: 95px;
  }

  #refreshNodeButton, #refreshNodeGroupsButton {
    line-height: 18px;
    vertical-align: top;
  }

  #PREDICATE_VALUE_NODE, #PREDICATE_VALUE_NODE_GROUPS {
    width: 115px;
  }

  label#matching {
    font-weight: bold;
    width: 175px;
  }

  div.form-row label.summary {
    font-weight: bold;
    width: 85px;
    float: none;
    text-align: left;
    vertical-align: middle;
    padding: 0px 4px 0px 0px;
    margin-left: 0px;
  }

  span.summary-row {
    float: none;
    text-align: left;
    vertical-align: middle;
    padding: 0px 0px 0px 0px;
  }

  span.summary-row span.summary-item {
    float: none;
    padding: 0px 5px 0px 0px;
  }

  span.elipse {
    font-size: 11px;
    color: #0000CC;
    margin: 0px 0px 0px 5px;
    padding: 0;
    text-decoration: underline;
    background-color: transparent;
    border: none;
    cursor: pointer;
  }

  div.form-row ul#summary_list {
    margin-left: 100px;
    padding: 0px 0px 0px 0px;
  }

  div.form-row ul#summary_list li {
    display: list-item;
    padding: 0px 3px 0px 0px;
  }

  div.form-row ul#summary_list li.summary_AND {
    font-weight: bold;
    list-style: none;
    margin-left: 20px;
  }

  div.form-row ul#summary_list li.summary-item span.summary_text italic {
    font-style: italic;
  }

  .floatLeft {
    float: left;
  }
</style>

<script type="text/javascript" language="JavaScript">
  var old_forms_showTab;
  function onLoad()
  {
   old_forms_showTab = forms_showTab;
   forms_showTab = new_forms_showTab;
   var lastTab = document.OMWSubscriptionForm.currentTab.value;
   if(lastTab != null &amp;&amp; lastTab != "" &amp;&amp; lastTab != "null")
   forms_showTab("attributes", lastTab, 5, "");
  }

  function new_forms_showTab(tabgroup, idx, length, state)
  {
   document.OMWSubscriptionForm.currentTab.value = idx;
   old_forms_showTab(tabgroup, idx, length, state);
  }

  // form validation to ensure that all required predicates are supplied
  function validateForm(theForm)
  {
    if(selectedButtonId == "saveButton:input")
    {
      if (isBlank(theForm['name'].value))
      {
        alert('The Name ' + MSG_CustomRequiredField);
        theForm['name'].focus();
        selectedButtonId = "";
        return false;
      }

    }

    disableFormButtons(theForm);
    addFormField(theForm, 'hidden', selectedButtonId, requestedFormAction);
    return true;
  }

  function hasSelectedOptions(source)
  {
    var selectedOptions = 0;
    for (var i=(source.options.length-1); i>=0; i--)
    {
      if(source.options[i].selected)
        selectedOptions++;
    }
    return selectedOptions != 0;
  }

  function setSelectionOptions(source, target)
  {
    // clear the left list
    removeAllOptions(target);
    // copy from source to left list
    copySelectedOptions(source, target);
  }

  function removeAllOptions(from)
  {
    for (var i=(from.options.length-1); i>=0; i--)
    {
      from.options[i] = null;
    }
    from.selectedIndex = -1;
  }

  function selectAllTargetOptions(theForm, name)
  {
    var target = theForm[name];
    // first select all of the options that match the regexp
    if(target != null) {
      selectAllOptions(target);
    }
  }

  function toggleDiv(id)
  {
    toggleDivNoImage(id);
  }

  function showDivIfNecessary(id)
  {
    var theStatus = document.getElementById(id).style.visibility;
    if (theStatus == 'hidden') {
      document.getElementById(id).style.visibility = 'visible';
      document.getElementById(id).style.display = 'block';
    }
  }

  function hideDivIfNecessary(id)
  {
    var theStatus = document.getElementById(id).style.visibility;
    if (theStatus == 'visible') {
      document.getElementById(id).style.visibility = 'hidden';
      document.getElementById(id).style.display = 'none';
    }
  }

  function popupSearch(href, name)
  {
    if (!window.focus) return true;
    windowPopup(href , name, '800','600','center','front');
    return false;
  }

  // this is called by submitCloseChildSubmitParent
  function submitRefresh()
  {
    disableFormButtons(document.forms['OMWSubscriptionForm']);
    addFormField(document.forms['OMWSubscriptionForm'], 'hidden', 'refreshButton', 'refreshButton');
    setTimeout("document.forms['OMWSubscriptionForm'].submit()", 500);
  }

  function sortListPredicates(theForm)
  {
    for (var i = 0; i &lt; theForm.elements.length; i++)
    {
      if (theForm.elements[i].type == "select-multiple")
      {
        if ((theForm.elements[i].name).substr(0, 16) == "PREDICATE_VALUE_")
        {
          sortSelect(theForm.elements[i]);
        }
      }
    }
  }

  function redirectForm()
  {

  }

</script>

<input type="hidden" name="currentTab" value="<%=request.getParameter("currentTab")%>" />

<text-widget id="name">
  <value><%= subscriptionBean.getName() %></value>
</text-widget>

<group label="Attributes">

<tab-group id="attributes">

<%
  if(!creatingSubscription)
  {
%>

    <tab-content id="summary_tab" label="Summary">
        <div class="form-row">
          <label id="matching">Matching Any Event Where</label>
        </div>
        <div class="form-row">
        <ul id="summary_list">
<%
  iterator = subscriptionBean.getPredicateIterator();
  boolean firstNonEmptyPredicate = true;
  while(iterator.hasNext())
  {
     final PredicateBean predicate = iterator.next();
     if(!predicate.getSelectedValues().isEmpty())
     {
       String summary = predicateSummaryNamesMap.get(predicate.getPredicateName());
       String predPosition = predicateTabPositionMap.get(predicate.getPredicateName());
%>
		     <% if(!firstNonEmptyPredicate) { %>
              <li class="summary_AND">
              <span class="summary_text">AND</span>
              </li>
             <%}%>

          <li class="summary-item">
            <span class="predicate_data"><%=predicate.getPredicateName()%></span>
			<span class="summary_text italic"> <%=predicate.getSelectedOperatorType()%></span>
            <span class="predicate_data"> (<%=summary%></span>
            <% if(summary.length() == MAX_DISPLAY_CHARACTERS) { %>
            <span class="elipse" onclick="forms_showTab('attributes', <%=predPosition%>, <%=Integer.toString(tabCount)%>, '')" >...</span>
            <% } %>
            <span class="summary_text">)</span>
          </li>
<%
	   firstNonEmptyPredicate = false;
     }
  }
%>
        </ul>
        </div>

        <div class="form-row">
          <label class="summary">Available:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.isOnSunday())
          {
            out.print("<span class=\"summary-item\">Sun</span>");
          }
          if(subscriptionBean.isOnMonday())
          {
            out.print("<span class=\"summary-item\">Mon</span>");
          }
          if(subscriptionBean.isOnTuesday())
          {
            out.print("<span class=\"summary-item\">Tue</span>");
          }
          if(subscriptionBean.isOnWednesday())
          {
            out.print("<span class=\"summary-item\">Wed</span>");
          }
          if(subscriptionBean.isOnThursday())
          {
            out.print("<span class=\"summary-item\">Thu</span>");
          }
          if(subscriptionBean.isOnFriday())
          {
            out.print("<span class=\"summary-item\">Fri</span>");
          }
          if(subscriptionBean.isOnSaturday())
          {
            out.print("<span class=\"summary-item\">Sat</span>");
          }
%>

          <span class="summary-item"><%=subscriptionBean.getStartTime()%></span>
          <span class="summary-item">-</span>
          <span class="summary-item"><%=subscriptionBean.getEndTime()%></span>
        </span>
        </div>
        <div class="form-row">
          <label class="summary">Using:</label>
         <span class="summary-row">
<%
          if(subscriptionBean.hasAllDeviceFilter())
          {
            out.print("<span class=\"summary-item\">All Devices</span>");
          }
          else
          {
            ArrayList<String> types = subscriptionBean.getDeviceTypeOverrides();
            for(String type : types)
            {
%>
            <span class="summary-item"><%=type.substring(NotificationAPI.DEVICE_FILTER_FIELD_PREFIX.length())%></span>
<%
            }
          }
%>
          </span>
        </div>
<%
  if(!subscriptionBean.isSelfSubscription())
  {
%>
        <div class="form-row">
          <label class="summary">Targeting:</label>
         <span class="summary-row">
<%
         int charactersDisplayed = 0;
         ArrayList<String> recipients = subscriptionBean.getRecipients();
         for(String recipient : recipients)
         {
%>
            <span class="summary-item"><%=recipient%></span>
<%
           charactersDisplayed += recipient.length();
           if(charactersDisplayed > MAX_RECIPIENT_DISPLAY_CHARACTERS)
           {
             out.print("<span class=\"summary-item\">...</span>");
             break;
           }
         }
%>
          </span>
        </div>

<%
  }
%>

    </tab-content>

<%
  }
%>

    <tab-content id="netcool_events" label="Netcool Events">


<%
      PredicateBean nodePredicate = predicateNameMap.get(NODE_PREDICATE_NAME);
      ArrayList<String> selectedNodes = selectedPredicateValuesMap.get(NODE_PREDICATE_NAME);
%>
      <div class="form-row">
        <label class="widget" for="<%=nodePredicate.getPredicateValueWidgetId()%>">Node:</label>
        <span  id="<%=nodePredicate.getPredicateValueWidgetId()%>">
          <select size="5" multiple="0" id="<%=nodePredicate.getPredicateValueWidgetId()%>" name="<%=nodePredicate.getPredicateValueWidgetId()%>" >
            <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedNodes.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
<%
            for (String name : nodeList)
            {
%>
              <option value="<%= name%>" <% if(selectedNodes.contains(name))out.print("selected=\"true\""); %> ><%= name%></option>
<%
            }
%>
           </select>
        </span>
      </div>

<%
      PredicateBean managerPredicate = predicateNameMap.get(MANAGER_PREDICATE_NAME);
      ArrayList<String> selectedManagers = selectedPredicateValuesMap.get(MANAGER_PREDICATE_NAME);
%>
      <div class="form-row">
        <label class="widget" for="<%=managerPredicate.getPredicateValueWidgetId()%>">Manager:</label>
        <span  id="<%=managerPredicate.getPredicateValueWidgetId()%>">
          <select size="5" multiple="0" id="<%=managerPredicate.getPredicateValueWidgetId()%>" name="<%=managerPredicate.getPredicateValueWidgetId()%>" >
            <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedManagers.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
<%
            for (String name : managerList)
            {
%>
              <option value="<%= name%>" <% if(selectedManagers.contains(name))out.print("selected=\"true\""); %> ><%= name%></option>
<%
            }
%>
           </select>
        </span>
      </div>

<%
      PredicateBean alertGroupPredicate = predicateNameMap.get(ALERT_GROUP_PREDICATE_NAME);
      ArrayList<String> selectedAlertGroups = selectedPredicateValuesMap.get(ALERT_GROUP_PREDICATE_NAME);
%>
      <div class="form-row">
        <label class="widget" for="<%=alertGroupPredicate.getPredicateValueWidgetId()%>">AlertGroup:</label>
        <span  id="<%=alertGroupPredicate.getPredicateValueWidgetId()%>">
          <select size="5" multiple="0" id="<%=alertGroupPredicate.getPredicateValueWidgetId()%>" name="<%=alertGroupPredicate.getPredicateValueWidgetId()%>" >
            <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedAlertGroups.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>
<%
            for (String name : alertGroupList)
            {
%>
              <option value="<%= name%>" <% if(selectedAlertGroups.contains(name))out.print("selected=\"true\""); %> ><%= name%></option>
<%
            }
%>
           </select>
        </span>
      </div>
<%
      PredicateBean severityPredicate = predicateNameMap.get(SEVERITY_PREDICATE_NAME);
      ArrayList<String> selectedSeverities = selectedPredicateValuesMap.get(SEVERITY_PREDICATE_NAME);
%>
      <div class="form-row">
        <label class="widget" for="<%=severityPredicate.getPredicateValueWidgetId()%>">Severity:</label>
        <span  id="<%=severityPredicate.getPredicateValueWidgetId()%>">
          <select size="5" multiple="0" id="<%=severityPredicate.getPredicateValueWidgetId()%>" name="<%=severityPredicate.getPredicateValueWidgetId()%>" >
            <option value="<%=subscriptionBean.getAnyPredicateListValue() %>" <% if(selectedSeverities.contains(subscriptionBean.getAnyPredicateListValue()))out.print("selected=\"true\""); %> >-- ANY --</option>

              <option value="Critical" <% if(selectedSeverities.contains("Critical"))out.print("selected=\"true\""); %> >Critical</option>
              <option value="Major" <% if(selectedSeverities.contains("Major"))out.print("selected=\"true\""); %> >Major</option>
              <option value="Minor" <% if(selectedSeverities.contains("Minor"))out.print("selected=\"true\""); %> >Minor</option>
              <option value="Warning" <% if(selectedSeverities.contains("Warning"))out.print("selected=\"true\""); %> >Warning</option>
              <option value="Indeterminate" <% if(selectedSeverities.contains("Indeterminate"))out.print("selected=\"true\""); %> >Indeterminate</option>
              <option value="Clear" <% if(selectedSeverities.contains("Clear"))out.print("selected=\"true\""); %> >Clear</option>
           </select>
        </span>
      </div>

    </tab-content>

<%
  if(!subscriptionBean.allOverridesSuppressed() || !subscriptionBean.isTimeframeSuppressed())
  {
%>
    <tab-content id="pref_tab" label="Preferences">

      <subscription-timeframe group-label="Timeframe" />
      <subscription-overrides group-label="Overrides" />

    </tab-content>

<%} %>

<%
  if(!subscriptionBean.isSelfSubscription())
  {
    if(isLaterVersion)
    {
%>
    <tab-content id="assigned_tab" label="Assign">

      <subscribed-recipients group-label="Recipients" />

    </tab-content>
<%
	}
	else if(!creatingSubscription)
	{
%>
    <tab-content id="assigned_tab" formsOnShow="redirectForm();">

      <tab-label><a href="SubscriptionMembers.do?subscriptionId=<%=request.getParameter("subscriptionId")%>">Assign</a></tab-label>

    </tab-content>
<%
	}
  }
%>

</tab-group>

</group>

</subscription-panel>